TITLE("Array")
REF("::Array::class")
REF("::Array::Add()")
REF("::Array::Add(const T&)")
REF("::Array::AddPick(pick_ T&)")
REF("::Array::Add(T*)")
REF("::Array::operator[](int)const")
REF("::Array::operator[](int)")
REF("::Array::GetCount()const")
REF("::Array::IsEmpty()const")
REF("::Array::Trim(int)")
REF("::Array::SetCount(int)")
REF("::Array::SetCount(int,const T&)")
REF("::Array::SetCountR(int)")
REF("::Array::SetCountR(int,const T&)")
REF("::Array::Clear()")
REF("::Array::At(int)")
REF("::Array::At(int,const T&)")
REF("::Array::Shrink()")
REF("::Array::Reserve(int)")
REF("::Array::GetAlloc()const")
REF("::Array::Set(int,const T&,int)")
REF("::Array::Remove(int,int)")
REF("::Array::Remove(const int*,int)")
REF("::Array::Remove(const::Vector<int>&)")
REF("::Array::InsertN(int,int)")
REF("::Array::Insert(int)")
REF("::Array::Insert(int,const T&,int)")
REF("::Array::Insert(int,const::Array&)")
REF("::Array::Insert(int,const::Array&,int,int)")
REF("::Array::Append(const::Array&)")
REF("::Array::Append(const::Array&,int,int)")
REF("::Array::InsertPick(int,pick_::Array&)")
REF("::Array::AppendPick(pick_::Array&)")
REF("::Array::Swap(int,int)")
REF("::Array::Move(int,int)")
REF("::Array::Detach(int)")
REF("::Array::Set(int,T*)")
REF("::Array::Insert(int,T*)")
REF("::Array::Drop(int)")
REF("::Array::Top()")
REF("::Array::Top()const")
REF("::Array::PopDetach()")
REF("::Array::Swap(::Array&)")
REF("::Array::operator<<(const T&)")
REF("::Array::operator<<(T*)")
REF("Array& operator|(pick_ T& x)")
REF("::Array::IsPicked()const")
REF("::Array::Serialize(::Stream&)")
REF("::Array::Array()")
REF("::Array::~Array()")
REF("::Array::Array(pick_::Array&)")
REF("::Array::operator=(pick_::Array&)")
REF("::Array::Array(const::Array&,int)")
REF("::DeepCopyOption::operator<<=(T&,const T&)")
REF("::Array::ValueType::typedef")
REF("::Array::Iterator::class")
REF("::Array::ConstIterator::class")
REF("::Array::Begin()")
REF("::Array::End()")
REF("::Array::GetIter(int)")
REF("::Array::Begin()const")
REF("::Array::End()const")
REF("::Array::GetIter(int)const")
REF("::Array::Swap(::Array&,::Array&)")
REF("::Array::IterSwap(::Array::Iterator,::Array::Iterator)")
TOPIC_TEXT(
"[2 $$0,0#00000000000000000000000000000000:Default][l288;i1120;a17;O9;~~~.1408;2 "
"$$1,0#10431211400427159095818037425705:param][a83;*R6 $$2,5#31310162474203024125188417583966:caption][b83;*4 "
"$$3,5#07864147445237544204411237157677:title][i288;O9;C2 $$4,6#40027414424643823182269349404212:item][b42;a42;2 "
"$$5,5#45413000475342174754091244180557:text][l288;b17;a17;2 $$6,6#27521748481378242620020725143825:desc][l321;t246;C@5;1 "
"$$7,7#20902679421464641399138805415013:code][b2503; $$8,0#65142375456100023862071332075487:separator][*@(0.0.255)2 "
"$$9,0#83433469410354161042741608181528:base][t4167;C $$10,0#37138531426314131251341829483380:class][l288;a17;*1 "
"$$11,11#70004532496200323422659154056402:requirement][i417;b42;a42;O9;~~~.416;2 $$12,12#10566046415157235020018451313112:tparam][b167;C2 "
"$$13,13#92430459443460461911108080531343:item1][i288;a42;O9;C2 $$14,14#77422149456609303542238260500223:item2][*@2$(0.128.128) "
"$$15,15#34511555403152284025741354420178:NewsDate][l321;*C$7;2 $$16,16#03451589433145915344929335295360:result][l321;b83;a83;*C$7;2 "
"$$17,17#07531550463529505371228428965313:result`-line][l160;t4167;*C+117 $$18,5#88603949442205825958800053222425:package`-title][ "
"$$19,0#53580023442335529039900623488521:gap][t4167;C2 $$20,20#70211524482531209251820423858195:class`-nested][b50;2 "
"$$21,21#03324558446220344731010354752573:Par][{_}%EN-US [s2;~~~64; Array&][s10;~~~64; "
"template <class [*@4 T]>&][s0;3 &][s10;:`:`:Array`:`:class:~~~64;* [* class ]Array&][s0; "
"&][s12; [*C@4 T]-|Type or base class of elements stored in Array. There is no common "
"requirement for T.&][s5; The most universal form of basic random access container. "
"Its features are derived from fact that typically it is  implemented using indirect "
"container of pointers to T like Vector<T`*>. Nevertheless it supports common concepts "
"as ownership of contained elements, reference (not pointer) access to elements and "
"so on.&][s5; It provides almost all operations of Vector with the same semantics "
"and almost any Vector can be dir")
TOPIC_TEXT(
"ectly replaced by Array. On the other hand, it provides some special operations "
"impossible for Vector and most important, it never invalidates references (that means "
"C`+`+ references and pointers) to elements (it often invalidates iterators, though).&][s5; "
"Array can be also used to store polymorphic elements `- stored elements could be "
"derived from T. To store such elements, you pass pointer to element created on heap. "
"Still, Array takes over ownership of such element (it e.g. deletes it when appropriate). "
"You can also use this method to create Array of elements that do not have either "
"pick, deep copy constructor nor default constructor.&][s5; There are also operations "
"that allow detaching an element from Array, removing it but not destroying. Pointer "
"to such element is returned from this operation and Array gives up ownership.&][s5; "
"Disadvantage of Array over Vector is performance `- most operations are significantly "
"slower than Vector`'s one (by factor up to 8, depends on speed of malloc/free). Still, "
"some operations might be even faster, e.g. Insert and Remove operations usually move "
"much less memory.&][s5; As for memory, for small size of elements, Array memory consumption "
"is significantly worse than Vector consumption. As size of elements grows, Array "
"starts to be better than Vector.&][s5;~~~.704; Iterators to Array satisfy all C`+`+ "
"standard library requirements for random access iterator plus they allow assignment "
"(and copy constructor) and testing for 0 (that is NULL) pointer.&][s5; Like any other "
"NTL container, Array is [*/^topic`:`/`/Core`/srcdoc`/Moveable`$en`-us^ moveable][*/ "
" ]type with [*/^topic`:`/`/Core`/srcdoc`/pick`_`$en`-us^ pick and optional deep copy] "
"transfer semantics. Calling methods of picked Array is logic error with exception "
"of&][s0;C+75 void [* operator`=](pick`_ Array`& [*@3 v])&][s0;/+75 [/C void ][*/C "
"operator<<`=][/C (const Array`& ][*/C@3 v][/C )][/  ](defined using DeepCopyOptionTemplate)&][s0;C+75 "
"void [* Clear]()&][s0;C+75 bool [")
TOPIC_TEXT(
"* IsPicked]() const&][s5; Optional deep copy is implemented through DeepCopyOptionTemplate "
"macro.&][s3; Members&][s0;3 &][s4;:`:`:Array`:`:Add`(`): T`& [* Add]()&][s6; Adds "
"new default constructed element to Array.&][s11; Requires T to have default constructor.&][s11; "
"Invalidates iterators to Array.&][s1; [*/ Return value]-|Reference to newly added "
"default constructed element.&][s0;3 &][s4;:`:`:Array`:`:Add`(const T`&`): void [* "
"Add](const T`& [*@3 x])&][s6; Adds new element with specified value to Array.&][s11; "
"Requires T to have deep copy constructor.&][s11; Invalidates iterators to Array.&][s1; "
"[*C@3 x]-|The value that is copied to newly created element.&][s0;3 &][s4;:`:`:Array`:`:AddPick`(pick`_ "
"T`&`): void [* AddPick](pick`_ T`& [*@3 x])&][s6; Adds new element to Array and picks "
"value of parameter to it. &][s11; Requires T to have pick constructor.&][s11; Invalidates "
"iterators to Array.&][s1; [*C@3 x]-|Source instance of T that is to be picked.&][s0;3 "
"&][s4;:`:`:Array`:`:Add`(T`*`): T`& [* Add](T `*[*@3 newt])&][s6; Adds new element "
"to Array. Element is specified by pointer to object created using operator new. Array "
"takes over ownership of this this object. This variant allows use of Array as polymorphic "
"container, because type of added element can be also derived from T as well. No constructor "
"is applied. &][s1; [*C@3 newt]-|Object to be added.&][s1; [*/ Return value]-|Reference "
"to object  (that is [* `*newt]).&][s4; [%00-00* template<class TT>][%00-00*@4  TT][%00-00 "
"`&_][%00-00* Create][%00-00 ()]&][s6; Creates and adds a new element to Array.&][s11; "
"Requires T to have default constructor.&][s1; [*C@4 TT]-|Type of new element.&][s1; "
"[*/ Return value]-|Reference to newly created element.&][s0;3 &][s4;:`:`:Array`:`:operator`[`]`(int`)const:~~~.992; "
"const T`& [* operator`[`]](int [*@3 i]) const&][s6; Returns a reference to the element "
"at specified position.&][s1; [*C@3 i]-|Position of element.&][s1; [*/ Return value]-|Constant "
"reference to the element.&][s0;3 &")
TOPIC_TEXT(
"][s4;:`:`:Array`:`:operator`[`]`(int`): T`& [* operator`[`]](int [*@3 i])&][s6; "
"Returns a reference to the element at specified position.&][s1; [*C@3 i]-|Position "
"of element.&][s1; [*/ Return value]-|Reference to the element.&][s0;3 &][s4;:`:`:Array`:`:GetCount`(`)const: "
"int [* GetCount]() const&][s6; Return the number of elements in Array.&][s1; [*/ "
"Return value]-|Actual number of elements.&][s0;3 &][s4;:`:`:Array`:`:IsEmpty`(`)const: "
"bool [* IsEmpty]() const&][s6; Tests whether Array is empty. Same as GetCount() `=`= "
"0.&][s1; [*/ Return value]-|true if Array is empty, false otherwise.&][s0;3 &][s4;:`:`:Array`:`:Trim`(int`): "
"void [* Trim](int [*@3 n])&][s6; Reduces number of elements in Array to specified "
"number. Required number must be less than or equal to actual number of elements in "
"Array.&][s1; [*C@3 n]-|Required number of elements.&][s0;3 &][s4;:`:`:Array`:`:SetCount`(int`): "
"void [* SetCount](int [*@3 n])&][s6; Changes count of elements in Array to specified "
"value. If required number of elements is greater than actual number, newly added "
"elements are default constructed. If Array has to increase capacity, the new capacity "
"will exactly match required number of elements (unlike [* SetCountR]).&][s11; Requires "
"T to have default constructor.&][s11; Invalidates iterators to Array.&][s1; [*C@3 "
"n]-|Required number of elements.&][s0;3 &][s4;:`:`:Array`:`:SetCount`(int`,const "
"T`&`): void [* SetCount](int [*@3 n], const T`& [*@3 init])&][s6; Changes count of "
"elements in Array to specified value. If required number of elements is greater than "
"actual number, newly added elements are initialized to specified value using copy "
"constructor. If Array has to increase capacity, the new capacity will exactly match "
"required number of elements (unlike [* SetCountR]).&][s11; Requires T to have deep "
"copy constructor.&][s11; Invalidates iterators to Array.&][s1; [*C@3 n]-|Required "
"number of elements.&][s1; [*C@3 init]-|Initialization value of newly added elements.&][s0;3 "
"&][s4;:`:`:A")
TOPIC_TEXT(
"rray`:`:SetCountR`(int`): void [* SetCountR](int [*@3 n])&][s6; Changes count of "
"elements in Array to specified value. If required number of elements is greater than "
"actual number, newly added elements are default constructed. If Array has to increase "
"capacity, the new capacity will be greater than required number of elements (unlike "
"[* SetCount]) to allow adding other elements without further increasing capacity.&][s11; "
"Requires T to have default constructor.&][s11; Invalidates iterators to Array.&][s1; "
"[*C@3 n]-|Required number of elements.&][s0;3 &][s4;:`:`:Array`:`:SetCountR`(int`,const "
"T`&`):~~~.992; void [* SetCountR](int [*@3 n], const T`& [*@3 init])&][s6; Changes "
"count of elements in Array to specified value. If required number of elements is "
"greater than actual number, newly added elements are initialized to specified value "
"using copy constructor. If Array has to increase capacity, the new capacity will "
"be greater than required number of elements (unlike [* SetCount]) to allow adding "
"other elements without further increasing capacity.&][s11; Requires T to have deep "
"copy constructor.&][s11; Invalidates iterators to Array.&][s1; [*C@3 n]-|Required "
"number of elements.&][s1; [*C@3 init]-|Initialization value of newly added elements.&][s0;3 "
"&][s4;:`:`:Array`:`:Clear`(`):~~~.992; void [* Clear]()&][s6; Removes all elements "
"from Array. Capacity is also cleared to zero.&][s11; Invalidates iterators to Array.&][s0;3 "
"&][s4;:`:`:Array`:`:At`(int`):~~~.992; T`& [* At](int [*@3 i])&][s6; If specified "
"position is lower than number of elements in Array ([* i < GetCount()]), returns "
"reference to element at specified position. Otherwise increases number of elements "
"in Array to [* i `+ 1]. Newly added elements are default constructed. If Array has "
"to increase capacity, the new capacity will be greater than required number of elements "
"to allow adding other elements without further increasing capacity.&][s11; Requires "
"T to have default constructor.&][s11; Invalidates iterator")
TOPIC_TEXT(
"s to Array.&][s1; [*C@3 i]-|Position of required element.&][s1; [*/ Return value]-|Reference "
"to required element.&][s0;3 &][s4;:`:`:Array`:`:At`(int`,const T`&`): T`& [* At](int "
"[*@3 i], const T`& [*@3 x])&][s6; If specified position is lower than number of elements "
"in Array ([* i < GetCount()]), returns reference to element at specified position. "
"Otherwise increases number of elements in Array to [* i `+ 1]. Newly added elements "
"are copy constructed from [* x]. If Array has to increase capacity, the new capacity "
"will be greater than required number of elements to allow adding other elements without "
"further increasing capacity.&][s11; Requires T to have deep copy constructor.&][s11; "
"Invalidates iterators to Array.&][s1; [*C@3 i]-|Position of required element.&][s1; "
"[*C@3 x]-|Initialization value of newly added elements.&][s1; [*/ Return value]-|Reference "
"to required element.&][s0;3 &][s4;:`:`:Array`:`:Shrink`(`): void [* Shrink]()&][s6; "
"Minimizes memory consumption of Array by decreasing capacity to number of elements.&][s0;3 "
"&][s4;:`:`:Array`:`:Reserve`(int`):~~~.992; void [* Reserve](int [*@3 xtra])&][s6; "
"Reserves capacity. If required capacity is greater than current capacity, capacity "
"is increased to the required value.&][s1; [*C@3 xtra]-|Required capacity.&][s0;3 "
"&][s4;:`:`:Array`:`:GetAlloc`(`)const:~~~.992; int [* GetAlloc]() const&][s6; Returns "
"current capacity of Array.&][s1; [*/ Return value]-|Capacity of Array.&][s0;3 &][s4;:`:`:Array`:`:Set`(int`,const "
"T`&`,int`): void [* Set](int [*@3 i], const T`& [*@3 x], int [*@3 count] `= 1)&][s6; "
"Sets requested number of elements starting at the position [* i] to the specified "
"value. If required number of elements exceeds existing elements of Array then elements "
"are added to Array.&][s11; Requires T to have deep copy constructor.&][s11; Invalidates "
"iterators to Array.&][s1; [*C@3 i]-|Starting position.&][s1; [*C@3 x]-|Value.&][s1; "
"[*C@3 count]-|Number of elements.&][s0;3 &][s4;:`:`:Array`:`:Remove`(int`,int`): "
"void")
TOPIC_TEXT(
" [* Remove](int [*@3 i], int [*@3 count] `= 1)&][s6; Removes requested number of "
"elements.&][s11; Invalidates iterators to Array.&][s1; [*C@3 i]-|Position.&][s1; "
"[*C@3 count]-|Number of elements to remove.&][s0;3 &][s4;:`:`:Array`:`:Remove`(const "
"int`*`,int`): void [* Remove](const int `*[*@3 sorted`_list], int [*@3 n])&][s6; "
"Removes number of elements from Array. Time of operation almost does not depend on "
"number of elements.&][s11; Invalidates iterators to Array.&][s1; [*C@3 sorted`_list]-|Pointer "
"to array of positions to remove. It must be sorted from lowest to greatest value.&][s1; "
"[*C@3 n]-|Number of elements to remove.&][s0;3 &][s4;:`:`:Array`:`:Remove`(const`:`:Vector`<int`>`&`): "
"void [* Remove](const Vector<int>`& [*@3 sorted`_list])&][s6; Removes number of elements "
"form Array. Same as [* Remove(sorted`_list, sorted`_list.GetCount())].&][s11; Invalidates "
"iterators to Array.&][s1; [*C@3 sorted`_list]-|Sorted Vector of positions to remove.&][s0;3 "
"&][s4;:`:`:Array`:`:InsertN`(int`,int`): void [* InsertN](int [*@3 i], int [*@3 count] "
"`= 1)&][s6; Inserts a specified number of default constructed elements at a specified "
"position.&][s11; Requires T to have default constructor.&][s11; Invalidates iterators "
"to Array.&][s1; [*C@3 i]-|Position.&][s1; [*C@3 count]-|Number of elements to insert.&][s0;3 "
"&][s4;:`:`:Array`:`:Insert`(int`):~~~.992; T`& [* Insert](int [*@3 i])&][s6; Inserts "
"one default constructed element at the specified position.&][s1;*1 Requires T to "
"have default constructor.&][s11; Invalidates iterators to Array.&][s1; [*C@3 i]-|Position.&][s0;3 "
"&][s4;:`:`:Array`:`:Insert`(int`,const T`&`,int`): void [* Insert](int [*@3 i], const "
"T`& [*@3 x], int [*@3 count] `= 1)&][s6; Inserts a specified number of elements, "
"setting them to a specified value.&][s11;~~~.992; Requires T to have deep copy constructor.&][s11; "
"Invalidates iterators to Array.&][s1; [*C@3 i]-|Position.&][s1; [*C@3 x]-|Value of "
"inserted elements.&][s1; [*C@3 count]-|Number of elements to insert.")
TOPIC_TEXT(
"&][s0;3 &][s4;:`:`:Array`:`:Insert`(int`,const`:`:Array`&`):~~~.992; void [* Insert](int "
"[*@3 i], const Array`& [*@3 x])&][s6; Inserts all elements from another Array.&][s11;~~~.992; "
"Requires T to have deep copy constructor.&][s11; Invalidates iterators to Array.&][s1; "
"[*C@3 i]-|Position.&][s1; [*C@3 x]-|Source Array.&][s0;3 &][s4;:`:`:Array`:`:Insert`(int`,const`:`:Array`&`,int`,int`):~~~.992; "
"void [* Insert](int [*@3 i], const Array`& [*@3 x], int [*@3 offset], int [*@3 count])&][s6; "
"Inserts a range of elements from another Array.&][s11;~~~.992; Requires T to have "
"deep copy constructor.&][s11; Invalidates iterators to Array.&][s1; [*C@3 i]-|Insertion "
"position.&][s1; [*C@3 x]-|Source Array.&][s1; [*C@3 offset]-|Position of first element "
"in source Array to be inserted.&][s1; [*C@3 count]-|Number of elements to insert.&][s0;3 "
"&][s4;:`:`:Array`:`:Append`(const`:`:Array`&`): void [* Append](const Array`& [*@3 "
"x])&][s6; Appends all elements of source Array.&][s11;~~~.992; Requires T to have "
"deep copy constructor.&][s11; Invalidates iterators to Array.&][s1; [*C@3 x]-|Source "
"Array.&][s0;3 &][s4;:`:`:Array`:`:Append`(const`:`:Array`&`,int`,int`): void [* Append](const "
"Array`& [*@3 x], int [*@3 o], int [*@3 c])&][s6; Appends a range of elements from "
"source Array.&][s11;~~~.992; Requires T to have deep copy constructor.&][s11; Invalidates "
"iterators to Array.&][s1; [*C@3 x]-|Source Array.&][s1; [*C@3 o]-|Position of first "
"element in source Array to be inserted.&][s1; [*C@3 c]-|Number of elements to insert.&][s0;3 "
"&][s4;:`:`:Array`:`:InsertPick`(int`,pick`_`:`:Array`&`): void [* InsertPick](int "
"[*@3 i], pick`_ Array`& [*@3 x])&][s6; Inserts source Array at specified position "
"using pick transfer semantics. It is faster than deep copy insert, does not use deep "
"copy constructor for T, but destroys source Array by picking.&][s11; Invalidates "
"iterators to Array.&][s1; [*C@3 i]-|Insertion position.&][s1; [*C@3 x]-|Source Array.&][s0;3 "
"&][s4;:`:`:Array`:`:AppendPick`(pick`_`:`:Array")
TOPIC_TEXT(
"`&`): void [* AppendPick](pick`_ Array`& [*@3 x])&][s6; Appends source Array using "
"pick transfer semantics. It is faster than deep copy insert, does not use deep copy "
"constructor for T, but destroys source Array by picking.&][s11; Invalidates iterators "
"to Array.&][s1; [*C@3 x]-|Source Array.&][s0;3 &][s4;:`:`:Array`:`:Swap`(int`,int`): "
"void [* Swap](int [*@3 i1], int [*@3 i2])&][s6; Swaps elements without using copy "
"constructor.&][s11; Invalidates iterators to Array.&][s1; [*C@3 i1]-|Position of "
"first element.&][s1; [*C@3 i2]-|Position of second element.&][s0;3 &][s4;:`:`:Array`:`:Move`(int`,int`): "
"void [* Move](int [*@3 i1], int [*@3 i2])&][s6; Removes element at position [* i1] "
"and inserts it at [* i2], without using copy constructor of T.&][s11; Invalidates "
"iterators to Array.&][s1; [*C@3 i1]-|Position of element to move.&][s1; [*C@3 i2]-|Target "
"position.&][s0;3 &][s4;:`:`:Array`:`:Detach`(int`): T `*[* Detach](int [*@3 i])&][s6; "
"Removes element at position [* i], giving up ownership. Client is responsible for "
"deletion of element.&][s11; Invalidates iterators to Array.&][s1; [*C@3 i]-|Position "
"of element to remove.&][s1; [*/ Return value]-|Pointer to element allocated on the "
"heap.&][s0;3 &][s4;:`:`:Array`:`:Set`(int`,T`*`): T`& [* Set](int [*@3 i], T `*[*@3 "
"newt])&][s6; Replaces element at the specified position by element created on heap. "
"Array takes over ownership of element.&][s1; [*C@3 i]-|Position.&][s1; [*C@3 newt]-|New "
"element allocated on heap.&][s1; [*/ Return value]-|Reference to new element.&][s0;3 "
"&][s4;:`:`:Array`:`:Insert`(int`,T`*`): void [* Insert](int [*@3 i], T `*[*@3 newt])&][s6; "
"Inserts element created on heap at the specified position. Array takes over ownership "
"of element.&][s11; Invalidates iterators to Array.&][s1; [*C@3 i]-|Insertion position.&][s1; "
"[*C@3 newt]-|New element allocated on heap.&][s1; [*/ Return value]-|Pointer to element "
"allocated on heap.&][s0;3 &][s4;:`:`:Array`:`:Drop`(int`): void [* Drop](int [*@3 "
"n] `= 1)&][s6; Drops s")
TOPIC_TEXT(
"pecified number of last elements in the Array (same as Trim(GetCount() `- n)).&][s1;* "
"[*C@3 n]-|Number of elements.&][s0;3 &][s4;:`:`:Array`:`:Top`(`): T`& [* Top]()&][s6; "
"Returns reference to the last element in the Array.&][s1; [*/ Return value]-|Reference "
"of last element in the Array.&][s0;3 &][s4;:`:`:Array`:`:Top`(`)const: const T`& "
"[* Top]() const&][s6; Returns constant reference to the last element in the Array.&][s1; "
"[*/ Return value]-|Reference of last element in the Array.&][s0;3 &][s4;:`:`:Array`:`:PopDetach`(`): "
"T `*[* PopDetach]()&][s6; Drops last element in the Array, giving up ownership (same "
"as Detach(GetCount() `- 1)). Client is responsible for deletion of element.&][s11; "
"Invalidates iterators to Array.&][s1; [*/ Return value]-|Pointer to element allocated "
"on the heap.&][s0;3 &][s4;:`:`:Array`:`:Swap`(`:`:Array`&`): void [* Swap](Array`& "
"[*@3 b])&][s6; Swaps content of Array with another array in constant time operation.&][s1; "
"[*C@3 b]-|Target array.&][s0;3 &][s4;:`:`:Array`:`:operator`<`<`(const T`&`): Array`& "
"[* operator<<](const T`& [*@3 x])&][s6; Operator replacement of [* void Add(const "
"T`&x)]. By returning reference to to Array allows adding more elements in single "
"expression, thus e.g. allowing to construct temporary Array as part of expression "
"like Foo((Array<int>() << 1 << 2 << 4)).&][s11; Requires T to have deep copy constructor.&][s11; "
"Invalidates iterators to Array.&][s1; [*C@3 x]-|The value that is copied to newly "
"created element.&][s1; [*/ Return value]-|Reference to Array (`*this).&][s0;3 &][s4;:`:`:Array`:`:operator`<`<`(T`*`): "
"Array`& [* operator<<](T `*[*@3 newt])&][s6; Operator replacement of [* void Add(T "
"`*x)]. By returning reference to to array allows adding more elements in single expression, "
"thus e.g. allowing to construct temporary array as part of expression like Foo((Array<Bar>() "
"<< new Bar << new DerivedFromBar)).&][s11; Invalidates iterators to Array.&][s1; "
"[*C@3 newt]-|Object to be added.&][s1; [*/ Return value]-|Refere")
TOPIC_TEXT(
"nce to Array (`*this).&][s0; &][s4;:Array`& operator`|`(pick`_ T`& x`): Array`& "
"[* operator`|](pick`_ T`& [*@3 x])&][s6; Operator replacement of [* void AddPick(pick`_ "
"T`&x)]. By returning reference to to array allows adding more elements in single "
"expression, thus e.g. allowing to construct temporary array as part of expression.&][s11; "
"Requires T to have pick constructor.&][s11; Invalidates iterators to Array.&][s1; "
"[*C@3 x]-|Source instance of T that is to be picked.&][s1; [*/ Return value]-|Reference "
"to Array (`*this).&][s0;3 &][s4;:`:`:Array`:`:IsPicked`(`)const: bool [* IsPicked]() "
"const&][s6; Returns [* true] if Array is in picked state.&][s1; [*/ Return value]-|[* "
"true] if Array is in picked state, [* false] otherwise.&][s0;3 &][s4;:`:`:Array`:`:Serialize`(`:`:Stream`&`): "
"void [* Serialize](Stream`& [*@3 s])&][s6; Serializes content of Array to/from Stream. "
"Works only if NTL is used as part of UPP.&][s11; Requires T to have serialization "
"operator defined.&][s1; [*C@3 s]-|Target/source stream.&][s0;3 &][s4;:`:`:Array`:`:Array`(`): "
"[* Array]()&][s6; Default constructor. Constructs empty Array.&][s0;3 &][s4;:`:`:Array`:`:`~Array`(`): "
"`~[* Array]()&][s6; Destructor. Calls destructors of all elements in Array.&][s0;3 "
"&][s4;:`:`:Array`:`:Array`(pick`_`:`:Array`&`): [* Array](pick`_ Array`& [*@3 v])&][s6; "
"Pick constructor. Transfers source Array in low constant time, but destroys it by "
"picking. &][s1; [*C@3 v]-|Source Array.&][s0;3 &][s4;:`:`:Array`:`:operator`=`(pick`_`:`:Array`&`):~~~.992; "
"void [* operator`=](pick`_ Array`& [*@3 v])&][s6; Pick operator. Transfers source "
"Array in low constant time, but destroys it by picking.&][s1; [*C@3 v]-|Source Array.&][s0;3 "
"&][s4;:`:`:Array`:`:Array`(const`:`:Array`&`,int`): [* Array](const Array`& [*@3 "
"v], int)&][s6; Optional deep copy constructor.&][s11; Requires T to have deep copy "
"constructor or optional deep copy constructor if Array stores only objects of type "
"T.&][s11; Requires polymorphic deep copy if Array stores also")
TOPIC_TEXT(
" objects of type derived from T.&][s1; [*C@3 v]-|Source Array.&][s0;3 &][s4;:`:`:DeepCopyOption`:`:operator`<`<`=`(T`&`,const "
"T`&`): void [* operator<<`=](const Array`& [*@3 v])&][s6; Optional deep copy operator. "
"Defined using DeepCopyOption base class.&][s11; Requires T to have deep copy constructor "
"or optional deep copy if Array stores only objects of type T.&][s11; Requires polymorphic "
"deep copy if Array stores also objects of type derived from T.&][s1; [*C@3 v]-|Source "
"Array.&][s0;3 &][s4;:`:`:Array`:`:ValueType`:`:typedef:* [* typedef T ]ValueType&][s6; "
"Typedef of T for use in templated algorithms.&][s0;3 &][s4;:`:`:Array`:`:Iterator`:`:class: "
"typedef [/ type] [* Iterator];&][s6; Iterator type.&][s0;3 &][s4;:`:`:Array`:`:ConstIterator`:`:class: "
"typedef [/ type] [* ConstIterator];&][s6; Constant iterator type.&][s0;3 &][s4;:`:`:Array`:`:Begin`(`): "
"Iterator [* Begin]()&][s6; Returns non`-constant iterator to the first element in "
"Array. &][s1; [*/ Return value]-|Iterator.&][s0;3 &][s4;:`:`:Array`:`:End`(`): Iterator "
"[* End]()&][s6; Returns non`-constant iterator to the position just beyond the last "
"element in Array.&][s1; [*/ Return value]-|Iterator.&][s0;3 &][s4;:`:`:Array`:`:GetIter`(int`): "
"Iterator [* GetIter](int [*@3 pos])&][s6; Returns non`-constant iterator to the element "
"at specified position. Same as [* Begin() `+ pos]. Benefit of this methods is that "
"in debug mode [* pos] is range checked.&][s1; [*C@3 pos]-|Required position.&][s1; "
"[*/ Return value]-|Iterator.&][s0;3 &][s4;:`:`:Array`:`:Begin`(`)const: ConstIterator "
"[* Begin]() const&][s6; Returns constant iterator to the first element in Array. "
"&][s1; [*/ Return value]-|Iterator.&][s0;3 &][s4;:`:`:Array`:`:End`(`)const: ConstIterator "
"[* End]() const&][s6; Returns constant iterator to the position just beyond the last "
"element in Array.&][s1; [*/ Return value]-|Iterator.-|&][s0;3 &][s4;:`:`:Array`:`:GetIter`(int`)const: "
"ConstIterator [* GetIter](int [*@3 pos]) const&][s6; Returns constant iterator to "
"the ")
TOPIC_TEXT(
"element at specified position. Same as [* Begin() `+ pos]. Benefit of this methods "
"is that in debug mode [* pos] is range checked.&][s1; [*C@3 pos]-|Required position.&][s1; "
"[*/ Return value]-|Iterator.&][s0;3 &][s4;:`:`:Array`:`:Swap`(`:`:Array`&`,`:`:Array`&`): "
"friend void [* Swap](Array`& [*@3 a], Array`& [*@3 b])&][s6; Specialization of generic "
"[* Swap] for Array. Swaps array in simple constant time operation.&][s1; [*C@3 a]-|First "
"Array to swap.&][s1; [*C@3 b]-|Second Array to swap.&][s0;3 &][s4;:`:`:Array`:`:IterSwap`(`:`:Array`:`:Iterator`,`:`:Array`:`:Iterator`): "
"friend void [* IterSwap](Iterator [*@3 a], Iterator [*@3 b])&][s6; Specialization "
"of generic [* IterSwap] for Array. Swaps elements in Array without any requirements "
"for T.&][s1; [*C@3 a]-|Iterator to first element.&][s1; [*C@3 b]-|Iterator to second "
"element.&][s0;3 ]")
