TITLE("BiVector")
REF("::BiVector::AddHead()")
REF("::BiVector::AddTail()")
REF("::BiVector::AddHead(const T&)")
REF("::BiVector::AddTail(const T&)")
REF("::BiVector::AddHeadPick(pick_ T&)")
REF("::BiVector::AddTailPick(pick_ T&)")
REF("::BiVector::Head()")
REF("::BiVector::Tail()")
REF("::BiVector::Head()const")
REF("::BiVector::Tail()const")
REF("::BiVector::DropHead()")
REF("::BiVector::DropTail()")
REF("::BiVector::operator[](int)")
REF("::BiVector::operator[](int)const")
REF("::BiVector::GetCount()const")
REF("::BiVector::IsEmpty()const")
REF("::BiVector::Clear()")
REF("::BiVector::Shrink()")
REF("::BiVector::Reserve(int)")
REF("::BiVector::GetAlloc()const")
REF("friend BiVector& operator<<(BiVector& b, const T& x)")
REF("friend BiVector& operator>>(const T& x, BiVector& b)")
REF("::BiVector::Serialize(::Stream&)")
REF("::BiVector::IsPicked()")
REF("::BiVector::~BiVector()")
REF("::BiVector::BiVector(pick_::BiVector&)")
REF("::BiVector::operator=(pick_::BiVector&)")
REF("::BiVector::BiVector(const::BiVector&,int)")
REF("::BiVector::ValueType::typedef")
REF("::BiVector::Iterator::typedef")
REF("::BiVector::ConstIterator::typedef")
REF("::BiVector::Begin()const")
REF("::BiVector::End()const")
REF("::BiVector::GetIter(int)const")
REF("::BiVector::Begin()")
REF("::BiVector::End()")
REF("::BiVector::GetIter(int)")
REF("::BiVector::Swap(::BiVector&,::BiVector&)")
TOPIC_TEXT(
"[2 $$0,0#00000000000000000000000000000000:Default][l288;i1120;a17;O9;~~~.1408;2 "
"$$1,0#10431211400427159095818037425705:param][a83;*R6 $$2,5#31310162474203024125188417583966:caption][b83;*4 "
"$$3,5#07864147445237544204411237157677:title][i288;O9;C2 $$4,6#40027414424643823182269349404212:item][b42;a42;2 "
"$$5,5#45413000475342174754091244180557:text][l288;b17;a17;2 $$6,6#27521748481378242620020725143825:desc][l321;t246;C@5;1 "
"$$7,7#20902679421464641399138805415013:code][b2503; $$8,0#65142375456100023862071332075487:separator][*@(0.0.255)2 "
"$$9,0#83433469410354161042741608181528:base][t4167;C $$10,0#37138531426314131251341829483380:class][l288;a17;*1 "
"$$11,11#70004532496200323422659154056402:requirement][i417;b42;a42;O9;~~~.416;2 $$12,12#10566046415157235020018451313112:tparam][b167;C2 "
"$$13,13#92430459443460461911108080531343:item1][i288;a42;O9;C2 $$14,14#77422149456609303542238260500223:item2][*@2$(0.128.128) "
"$$15,15#34511555403152284025741354420178:NewsDate][l321;*C$7;2 $$16,16#03451589433145915344929335295360:result][l321;b83;a83;*C$7;2 "
"$$17,17#07531550463529505371228428965313:result`-line][l160;t4167;*C+117 $$18,5#88603949442205825958800053222425:package`-title][ "
"$$19,0#53580023442335529039900623488521:gap][t4167;C2 $$20,20#70211524482531209251820423858195:class`-nested][b50;2 "
"$$21,21#03324558446220344731010354752573:Par][{_}%EN-US [s2;~~~64; BiVector&][s10;~~~64; "
"template <class [*@4 T]>&][s10;~~~64;* [* class ]BiVector&][s0; &][s1;l0;~~~.704; "
"[*C@4 T]-|Type of elements stored in Vector. T is required to be [*/^topic`:`/`/Core`/srcdoc`/Moveable`$en`-us^ "
"moveable][*/  ]and must have either [*/ deep copy constructor], [*/ pick constructor] "
"or [*/ default constructor].&][s5; Vector flavor of bidirectional container. Allows "
"adding elements at both sides of sequence at constant amortized time.&][s5; Like "
"any other NTL container, BiVector is [*/^topic`:`/`/Core`/srcdoc`/Moveable`$en`-us^ "
"moveable][/  ]type with [*/^topic`:`/`/Core`/srcdoc`/pick`_`$en`-us^ pick and optional "
"deep")
TOPIC_TEXT(
" copy] transfer semantics. Calling methods of picked BiVector is logic error with "
"exception of&][s0;C+75 void [* operator`=](pick`_ Vector`& [*@3 v])&][s0;/+75 [/C "
"void ][*/C operator<<`=][/C (const Vector`& ][*/C@3 v][/C )][/  ](defined using DeepCopyOptionTemplate)&][s0;C+75 "
"void [* Clear]()&][s0;C+75 bool [* IsPicked]() const&][s5; Optional deep copy is "
"implemented through DeepCopyOptionTemplate macro.&][s3; Members&][s0;3 &][s4;:`:`:BiVector`:`:AddHead`(`): "
"T`& [* AddHead]()&][s6; Adds new default constructed element at the head of BiVector. "
"The new element will be at position 0.&][s11; Requires T to have default constructor.&][s11; "
"Invalidates iterators and references to BiVector.&][s1; [*/ Return value]-|Reference "
"to newly added default constructed element.&][s0;3 &][s4;:`:`:BiVector`:`:AddTail`(`): "
"T`& [* AddTail]()&][s6; Adds new default constructed element at the tail of BiVector. "
"The new element will be at position GetCount() `- 1.&][s11; Requires T to have default "
"constructor.&][s11; Invalidates iterators and references to BiVector.&][s1; [*/ Return "
"value]-|Reference to newly added default constructed element.&][s0;3 &][s4;:`:`:BiVector`:`:AddHead`(const "
"T`&`): void [* AddHead](const T`& [*@3 x])&][s6; Adds new element with specified "
"value at the head of BiVector. The new element will be at position 0.&][s11; Requires "
"T to have deep copy constructor.&][s11; Invalidates iterators and references to BiVector.&][s1; "
"[*C@3 x]-|The value that is copied to the newly created element.&][s0;3 &][s4;:`:`:BiVector`:`:AddTail`(const "
"T`&`): void [* AddTail](const T`& [*@3 x])&][s6; Adds new element with specified "
"value at the tail of BiVector. The new element will be at position GetCount() `- "
"1.&][s11; Requires T to have deep copy constructor.&][s11; Invalidates iterators "
"and references to BiVector.&][s1; [*C@3 x]-|The value that is copied to the newly "
"created element.&][s0;3 &][s4;:`:`:BiVector`:`:AddHeadPick`(pick`_ T`&`): void [* "
"AddHeadPick](pick`_ T`& [*@3 x])&][s")
TOPIC_TEXT(
"6; Adds new element at the head of BiVector and picks value of parameter to it. "
"The new element will be at position 0.&][s11; Requires T to have pick constructor.&][s11; "
"Invalidates iterators and references to BiVector.&][s1; [*C@3 x]-|Source instance "
"of T that is to be picked.&][s0;3 &][s4;:`:`:BiVector`:`:AddTailPick`(pick`_ T`&`): "
"void [* AddTailPick](pick`_ T`& [*@3 x])&][s6; Adds new element at the tail of BiVector "
"and picks value of parameter to it. The new element will be at position GetCount() "
"`- 1.&][s11; Requires T to have pick constructor.&][s11; Invalidates iterators and "
"references to BiVector.&][s1; [*C@3 x]-|Source instance of T that is to be picked.&][s0;3 "
"&][s4;:`:`:BiVector`:`:Head`(`): T`& [* Head]()&][s6; Returns reference to the head "
"of BiVector. Same as operator`[`](0).&][s1; [*/ Return value]-|Reference to the head "
"of BiVector.&][s0;3 &][s4;:`:`:BiVector`:`:Tail`(`): T`& [* Tail]()&][s6; Returns "
"reference to the tail of BiVector. Same as operator`[`](GetCount() `- 1).&][s1; [*/ "
"Return value]-|Reference to the tail of BiVector.&][s0;3 &][s4;:`:`:BiVector`:`:Head`(`)const: "
"const T`& [* Head]() const&][s6; Returns reference to the head of BiVector. Same "
"as operator`[`](0).&][s1; [*/ Return value]-|Constant reference to the head of BiVector.&][s0;3 "
"&][s4;:`:`:BiVector`:`:Tail`(`)const: const T`& [* Tail]() const&][s6; Returns reference "
"to the tail of BiVector. Same as operator`[`](GetCount() `- 1).&][s1; [*/ Return "
"value]-|Constant reference to the tail of BiVector.&][s0;3 &][s4;:`:`:BiVector`:`:DropHead`(`): "
"void [* DropHead]()&][s6; Removes element at the head of BiVector.&][s11; Invalidates "
"iterators and references to BiVector.&][s0;3 &][s4;:`:`:BiVector`:`:DropTail`(`): "
"void [* DropTail]()&][s6; Removes element at the tail of BiVector.&][s11; Invalidates "
"iterators and references to BiVector.&][s0;3 &][s4;:`:`:BiVector`:`:operator`[`]`(int`): "
"T`& [* operator]`[`](int [*@3 i])&][s6; Returns a reference to the element at specified "
"position.&][s1; ")
TOPIC_TEXT(
"[*C@3 i]-|Position of element.&][s1; [*/ Return value]-|Reference to the element.&][s0;3 "
"&][s4;:`:`:BiVector`:`:operator`[`]`(int`)const: const T`& [* operator]`[`](int [*@3 "
"i]) const&][s6; Returns a reference to the element at specified position.&][s1; [*C@3 "
"i]-|Position of element.&][s1; [*/ Return value]-|Constant reference to the element.&][s0;3 "
"&][s4;:`:`:BiVector`:`:GetCount`(`)const: int [* GetCount]() const&][s6; Returns "
"the number of elements in BiVector.&][s1; [*/ Return value]-|Actual number of elements.&][s0;3 "
"&][s4;:`:`:BiVector`:`:IsEmpty`(`)const: bool [* IsEmpty]() const&][s6; Tests whether "
"BiVector is empty. Same as GetCount() `=`= 0.&][s1; [*/ Return value]-|true if Vector "
"is empty, false otherwise.&][s0;3 &][s4;:`:`:BiVector`:`:Clear`(`): void [* Clear]()&][s6; "
"Removes all elements from BiVector.&][s0;3 &][s4;:`:`:BiVector`:`:Shrink`(`):~~~.992; "
"void [* Shrink]()&][s6; Minimizes memory consumption of BiVector by minimizing capacity.&][s0;3 "
"&][s4;:`:`:BiVector`:`:Reserve`(int`): void [* Reserve](int [*@3 n])&][s6; Reserves "
"capacity. If required capacity is greater than the current capacity, capacity is "
"increased to the required value.&][s1; [*C@3 n]-|Required capacity.&][s0;3 &][s4;:`:`:BiVector`:`:GetAlloc`(`)const: "
"int [* GetAlloc]() const&][s6; Returns current capacity of BiVector.&][s1; [*/ Return "
"value]-|Capacity of BiVector.&][s4;:friend BiVector`& operator`<`<`(BiVector`& b`, "
"const T`& x`): friend BiVector`& [* operator]<<(BiVector`& [*@3 b], const T`& [*@3 "
"x])&][s6; Operator replacement of [* void AddTail(const T`&x)]. By returning reference "
"to the BiVector allows adding more elements in single expression, thus e.g. allowing "
"to construct temporary BiVector as part of expression like Foo(BiVector<int>() << "
"1 << 2 << 4).&][s11; Requires T to have deep copy constructor.&][s11; Invalidates "
"iterators and references to BiVector.&][s1; [*C@3 x]-|The value that is copied to "
"the newly created element.&][s1; [*/ Return value]-|Reference to BiVector (")
TOPIC_TEXT(
"that is `*this).&][s4;:friend BiVector`& operator`>`>`(const T`& x`, BiVector`& "
"b`): friend BiVector`& [* operator]>>(const T`& [*@3 x], BiVector`& [*@3 b])&][s6; "
"Operator replacement of [* void AddHead(const T`&x)]. By returning reference to the "
"BiVector allows adding more elements in single expression, thus e.g. allowing to "
"construct temporary BiVector as part of expression like Foo(1 >> (2 >> BiVector<int>())).&][s11; "
"Requires T to have deep copy constructor.&][s11; Invalidates iterators and references "
"to BiVector.&][s1; [*C@3 x]-|The value that is copied to the newly created element.&][s1; "
"[*/ Return value]-|Reference to BiVector (that is `*this).&][s0;3 &][s4;:`:`:BiVector`:`:Serialize`(`:`:Stream`&`): "
"void [* Serialize](Stream`& [*@3 s])&][s6; Serializes content of BiVector to/from "
"Stream. Works only if NTL is used as part of UPP.&][s11; Requires T to have serialization "
"operator defined.&][s1; [*C@3 s]-|Target/source stream.&][s0;3 &][s4;:`:`:BiVector`:`:IsPicked`(`): "
"[* BiVector]()&][s6; Default constructor. Constructs empty BiVector.&][s0;3 &][s4;:`:`:BiVector`:`:`~BiVector`(`): "
"`~[* BiVector]()&][s6; Destructor. Calls destructors of all elements in BiVector.&][s0;3 "
"&][s4;:`:`:BiVector`:`:BiVector`(pick`_`:`:BiVector`&`): [* BiVector](pick`_ BiVector`& "
"[*@3 src])&][s6; Pick constructor. Transfers source BiVector in low constant time, "
"but destroys it by picking.&][s1; [*C@3 src]-|Source BiVector.&][s0;3 &][s4;:`:`:BiVector`:`:operator`=`(pick`_`:`:BiVector`&`): "
"void [* operator]`=(pick`_ BiVector`& [*@3 src])&][s6; Pick operator. Transfers source "
"BiVector in low constant time, but destroys it by picking.&][s1; [*C@3 v]-|Source "
"BiVector.&][s0;3 &][s4;:`:`:BiVector`:`:IsPicked`(`): bool [* IsPicked]()&][s6; Returns "
"[* true] if BiVector is in picked state.&][s1; [*/ Return value]-|[* true] if BiVector "
"is in picked state, [* false] otherwise.&][s0;3 &][s4;:`:`:BiVector`:`:BiVector`(const`:`:BiVector`&`,int`): "
"[* BiVector](const BiVector`& [*@3 src], int)&][s6; Op")
TOPIC_TEXT(
"tional deep copy constructor.&][s11; Requires T to have deep copy constructor or "
"optional deep copy constructor.&][s1; [*C@3 v]-|Source BiVector.&][s0;3 &][s4;:`:`:BiVector`:`:ValueType`:`:typedef:* "
"[* typedef T ]ValueType&][s6; Typedef of T for use in templated algorithms.&][s0;3 "
"&][s4;:`:`:BiVector`:`:Iterator`:`:typedef: typedef [/ type] [* Iterator];&][s6; "
"Iterator type.&][s0;3 &][s4;:`:`:BiVector`:`:ConstIterator`:`:typedef: typedef [/ "
"type] [* ConstIterator];&][s6; Constant iterator type.&][s0;3 &][s4;:`:`:BiVector`:`:Begin`(`)const: "
"ConstIterator [* Begin]() const&][s6; Returns constant iterator to the first element "
"in BiVector.&][s1; [*/ Return value]-|Iterator.&][s0;3 &][s4;:`:`:BiVector`:`:End`(`)const: "
"ConstIterator [* End]() const&][s6; Returns constant iterator to the position just "
"beyond the last element in BiVector.&][s1; [*/ Return value]-|Iterator.&][s0;3 &][s4;:`:`:BiVector`:`:GetIter`(int`)const: "
"ConstIterator [* GetIter](int [*@3 pos]) const&][s6; Returns constant iterator to "
"the element at specified position. Same as [* Begin() `+ i]. Benefit of this methods "
"is that in debug mode [* pos] is range checked.&][s1; [*C@3 i]-|Required position.&][s1; "
"[*/ Return value]-|Iterator.&][s0;3 &][s4;:`:`:BiVector`:`:Begin`(`): Iterator [* "
"Begin]()&][s6; Returns non`-constant iterator to the first element in Vector.&][s1; "
"[*/ Return value]-|Iterator.&][s0;3 &][s4;:`:`:BiVector`:`:End`(`): Iterator [* End]()&][s6; "
"Returns non`-constant iterator to the position just beyond the last element in Vector.&][s1; "
"[*/ Return value]-|Iterator.&][s0;3 &][s4;:`:`:BiVector`:`:GetIter`(int`): Iterator "
"[* GetIter](int [*@3 pos])&][s6; Returns non`-constant iterator to the element at "
"specified position. Same as [* Begin() `+ pos]. Benefit of this methods is that in "
"debug mode [* pos] is range checked.&][s1; [*C@3 i]-|Required position.&][s1; [*/ "
"Return value]-|Iterator.&][s0;3 &][s4;:`:`:BiVector`:`:Swap`(`:`:BiVector`&`,`:`:BiVector`&`): "
"friend void [* Swap](BiVector`& [*@3 ")
TOPIC_TEXT(
"a], BiVector`& [*@3 b])&][s6; Specialization of generic [* Swap] for BiVector. Swaps "
"BiVector in low constant time operation.&][s1; [*C@3 a]-|First BiVector to swap.&][s1; "
"[*C@3 b]-|Second BiVector to swap.&][s0;3 ]")
