TITLE("Moveable")
TOPIC_TEXT(
"[2 $$0,0#00000000000000000000000000000000:Default][l288;i704;a17;O9;~~~.992;2 $$1,0#10431211400427159095818037425705:param][a83;*R6 "
"$$2,5#31310162474203024125188417583966:caption][b83;* $$3,5#07864147445237544204411237157677:title][b167;a42;C2 "
"$$4,6#40027414424643823182269349404212:item][b42;a42;2 $$5,5#45413000475342174754091244180557:text][l288;a17;2 "
"$$6,6#27521748481378242620020725143825:desc][l321;t246;C@5;1 $$7,7#20902679421464641399138805415013:code][b2503; "
"$$8,0#65142375456100023862071332075487:separator][*@(0.0.255)2 $$9,0#83433469410354161042741608181528:base][t4167;C "
"$$10,0#37138531426314131251341829483380:class][l288;a17;*1 $$11,11#70004532496200323422659154056402:requirement][i417;b42;a42;O9;~~~.416;2 "
"$$12,12#10566046415157235020018451313112:tparam][b167;C2 $$13,13#92430459443460461911108080531343:item1][i288;a42;O9;C2 "
"$$14,14#77422149456609303542238260500223:item2][*@2$(0.128.128) $$15,15#34511555403152284025741354420178:NewsDate][l321;*C$7;2 "
"$$16,16#03451589433145915344929335295360:result][l321;b83;a83;*C$7;2 $$17,17#07531550463529505371228428965313:result`-line][l160;t4167;*C+117 "
"$$18,5#88603949442205825958800053222425:package`-title][{_}%EN-US [s2; Moveable&][s5; "
"Moveable concept represents basic requirement for types stored in Vector flavor of "
"containers (namely Vector, BiVector, Index and VectorMap). To explain what is and "
"why it is so important let us first create very primitive Vector`-like container "
"template&][s7; template <class T>&][s7; class SimpleVector `{&][s7; -|T  `*vector;&][s7; "
"-|int capacity;&][s7; -|int items;&][s7; &][s7; -|void [* Expand()] `{&][s7; -|-|capacity "
"`= 2 `* capacity;&][s7; -|-|T `*newvector `= (T `*) new char`[capacity `* sizeof(T)`];&][s7; "
"-|-|for(int i `= 0; i < items; i`+`+) `{&][s7; -|-|-|[* new(newvector`[i`]) T(vector`[i`])];&][s7;* "
"[* -|-|-|]vector`[i`].T`::`~T();&][s7; -|-|`}&][s7; -|-|delete`[`] (char `*) vector;&][s7; "
"-|-|vector `= newvector;&][s7; -|`}&][s7; public:&][s7; -|void Add(const T`& x) `{&][s7; "
"-|-|")
TOPIC_TEXT(
"if(items >`= capacity) [* Expand()];&][s7; -|-|new(vector`[items`+`+`]) T(x);&][s7; "
"-|`}&][s7; -|T`& operator`[`](int i) `{ return vector`[i`]; `}&][s7; -|SimpleVector() "
"`{&][s7; -|-|vector `= NULL;&][s7; -|-|capacity `= items `= 0;&][s7; -|`}&][s7; -|`~SimpleVector() "
"`{&][s7; -|-|for(int i `= 0; i < items; i`+`+)&][s7; -|-|-|vector`[i`].T`::`~T();&][s7; "
"-|-|delete`[`] (char `*)vector;&][s7; -|`}&][s7; `};&][s5; This [* SimpleVector] "
"stores added elements in [* vector]. If there is not sufficient space left in [* "
"vector], [* SimpleVector] simply doubles its capacity using [* Expand] method. And "
"this method is what interests us `- because [* Expand ]requires means to copy values "
"of elements from the original [* vector] to new allocated one. Above version uses "
"placement new and copy constructor for this purpose. This also means that [* SimpleVector] "
"requires T to have copy constructor (in standard C`+`+ library terms: it must be "
"[/ copy`-constructible]). Now let us create a typical element that can be stored "
"in such container&][s7; class SimpleString `{&][s7; -|char `*text;&][s7; public:&][s7; "
"-|SimpleString(const char `*txt) `{&][s7; -|-|text `= new char`[strlen(txt)`];&][s7; "
"-|-|strcpy(text, txt);&][s7; -|`}&][s7; -|SimpleString(const SimpleString`& s) `{&][s7; "
"-|-|text `= new char`[strlen(s.text)`];&][s7; -|-|strcpy(text, s.text);&][s7; -|`}&][s7; "
"-|void operator`=(const SimpleString`& s) `{&][s7; -|-|delete`[`] text;&][s7; -|-|text "
"`= new char`[strlen(s.text)`];&][s7; -|-|strcpy(text, s.text);-|-|&][s7; -|`}&][s7; "
"-|SimpleString() `{&][s7; -|-|delete`[`] text;&][s7; -|`}&][s7; `};&][s5; and see "
"what happens when [* SimpleVector] of [* SimpleString]s is expanded: First, copies "
"of all elements are created, that means allocating new storage for [* text] member "
"of new element and copying source [* text] to it using [* strcpy]. A moment later, "
"[* Expand] invokes destructor for element, thus deleting all [* text]s in the original "
"elements. Does not it seem we are wastin")
TOPIC_TEXT(
"g a lot of CPU cycles just to make copies of things that we throw away moment later "
"anyway ? What if instead of making copies we could find a way to transfer original "
"element`'s [* text] members to new one and somehow disallow [* delete`[`] text] in "
"destructor? See how primitive it can be:&][s7; template <class T>&][s7; class SimpleVector "
"`{&][s7; -|T  `*vector;&][s7; -|int capacity;&][s7; -|int items;&][s7; &][s7; -|void "
"Expand() `{&][s7; -|-|capacity `= 2 `* capacity;&][s7; -|-|T `*newvector `= (T `*) "
"new char`[capacity `* sizeof(T)`];&][s7;* [* -|-|]memcpy(newvector, vector, items "
"`* sizeof(T));&][s7; -|-|delete`[`](char `*)vector;&][s7; -|-|vector `= newvector;&][s7; "
"-|`}&][s7; public:&][s7; -|void Add(const T`& x) `{&][s7; -|-|if(items >`= capacity) "
"Expand();&][s7; -|-|new(vector`[items`+`+`]) T(x);&][s7; -|`}&][s7; -|SimpleVector() "
"`{&][s7; -|-|vector `= NULL;&][s7; -|-|capacity `= items `= 0;&][s7; -|`}&][s7; -|`~SimpleVector() "
"`{&][s7; -|-|for(int i `= 0; i < items; i`+`+)&][s7; -|-|-|vector`[i`].T`::`~T();&][s7; "
"-|-|delete`[`] (char `*)vector;&][s7; -|`}&][s7; `};&][s5; For the moment please "
"ignore fact that by using memcpy to move non`-POD types we violate C`+`+ standard "
"(we will discuss it later). Now, what we get here is exactly what we wanted `- instead "
"of copy construction and destruction we simply copy raw binary data to the new location. "
"This way we simply get [* text ]member of elements to new expanded [* vector]. We "
"need to invoke neither copy constructor nor destructor when expanding vector. Not "
"a single CPU cycle lost.&][s5;*/ [*/ Types that can be moved in memory using memcpy "
"we call ]moveable.&][s5; Clearly not all types are moveable. Certainly, being moveable "
"has a lot to do with storing references to object itself or to its parts. E.g.&][s7; "
"struct Link `{&][s7; -|Link `*prev;&][s7; public:&][s7; -|Link()        `{ prev `= "
"NULL; `}&][s7; -|Link(Link `*p) `{ prev `= p; `}&][s7; `};&][s5; is [* not] moveable, "
"because memcpy`-ing to new location")
TOPIC_TEXT(
" would break existing links. We define these requirements for moveable types:&][s5;i150;O0; "
"If a type is fundamental, it is moveable.&][s5;i150;O0; Moveable types must not have "
"any virtual method nor virtual bases.&][s5;i150;O0; Base classes (if any) and any "
"instance variables are moveable.&][s5;i150;O0; No method of moveable object can store "
"any references to itself (this), its base subobjects or its instance variables to "
"any non`-local or static`-local variable or use it in function or method call that "
"does so.&][s5;i150;O0; Moveable type has to have either pick constructor or regular "
"copy constructor. This is a [/ fallback requirement] `- if some sinister compiler "
"writer would decide to make optimization described here impossible, templates requiring "
"moveable will still be implementable.&][s5; Example:&][s7; struct Foo;&][s7; &][s7; "
"Foo `*global`_foo;&][s0; &][s7; struct Foo `{&][s7; -|int a;&][s7; -|Foo `*foo;&][s7; "
"-|int `*ptr;&][s7; public:&][s7; -|void Set(Foo `* f) `{&][s7; -|-|foo `= f;&][s7; "
"-|`}&][s7; -|void Ok1() `{&][s7; -|-|Foo `*x `= this;&][s7; -|// assigning to local "
"variable&][s7; -|// `-> does not prevent Foo from being moveable&][s7; -|`}&][s7; "
"-|void Ok2() `{&][s7; -|-|memset(`&a, 0, sizeof(int));&][s7; -|// memset does not "
"store pointer&][s7; -|// `-> does not prevent Foo from being moveable&][s7; -|`}&][s7; "
"-|void Bad1() `{&][s7; -|-|foo `= this;&][s7; -|// assigning to non`-local variable&][s7; "
"-|// `-> makes Foo non`-moveable&][s7; -|`}&][s7; -|void Bad2() `{&][s7; -|-|ptr "
"`= `&a;&][s7; -|// assigning to non`-local variable&][s7; -|// `-> makes Foo non`-moveable&][s7; "
"-|`}&][s7; -|void Bad3() `{&][s7; -|-|global`_foo `= this;&][s7; -|// assigning to "
"non`-local variable&][s7; -|// `-> makes Foo non`-moveable&][s7; -|`}&][s7; -|void "
"Bad4(Foo`& another) `{&][s7; -|-|another.Set(this);&][s7; -|// Set stores reference&][s7; "
"-|// `-> makes Foo non`-moveable&][s7; -|`}&][s7; -|void Bad5() `{&][s7; -|-|static "
"int `*q `= `&a;&][s7; -|// assigning to ")
TOPIC_TEXT(
"static local variable&][s7; -|// `-> makes Foo non`-moveable&][s7; -|`}&][s7; &][s7; "
"`};&][s5; This requirements are satisfied by fairly large number of types, incidentally "
"most of types you ever wanted to store in container of elements of single type are "
"moveable. Most important, all NTL containers [* are ]moveable.&][s5; Note also that "
"moveable requirements do allow returning pointer to this or object`'s internals from "
"methods. Regular rules about validity of such pointers are to be assumed (means that "
"they might get invalidated when object referenced is a part of container and container "
"performs some operation).&][s5; Now we have effective method how to organize storing "
"of elements in containers. What we have to deal with is fact that being moveable "
"is part of object`'s interface. To make things safer we should disallow storing non`-moveable "
"elements in containers requiring moveable ones. We need to have a way how to declare "
"that type is moveable at compile time and also how to check it.&][s5; To achieve "
"this goal, you can mark moveable type using [* Moveable] base e.g.:&][s7; class SimpleString "
": Moveable<SimpleString> `{ ... `}&][s5; or add you can use [* NTL`_MOVEABLE ]macro "
"to mark types where you cannot change class interface:&][s7; NTL`_MOVEABLE(std`::string);&][s5; "
"Now that we can mark types to be moveable, we need a way to check a type for being "
"moveable. You can do it by adding&][s7; AssertMoveable<T>()&][s5; to some method "
"of template that gets compiled for any template argument `- destructor being the "
"most obvious place. This function is in turn defined only if [* T] is marked as Moveable.&][s5; "
"Finally, time has come to deal with C`+`+ standard. Current C`+`+ defines memcpy "
"only for POD types. Moveable concept requires memcpy of non`-POD types to be defined. "
"In fact, difference between POD and Moveable non`-POD types is existence of constructor "
"and non`-virtual destructor. To get things work, all we need is that result of memcpy`-ing "
"non`-POD type [* ")
TOPIC_TEXT(
"T ]is same as memcpy`-ing POD [* T1 ]type you would get by removing destructor and "
"constructor from [* T]. While this is still undefined by C`+`+, it is really hard "
"to imagine optimal C`+`+ implementation that would break this rule. Indeed, all current "
"implementations known support moveable semantics in a way we have defined here. All "
"current C`+`+ ABI do as well. Performance and other gains realized using moveable "
"concept are too big to ignore.&][s5; Moreover, if for some reason on specific platform "
"moveable optimization described here is impossible, fallback requirement would provide "
"a way for slower but 100% standard compliant implementation.]")
