TITLE("About Callbacks and Bars")
TOPIC_TEXT(
"[2 $$0,0#00000000000000000000000000000000:Default][l288;i1120;a17;O9;~~~.1408;2 "
"$$1,0#10431211400427159095818037425705:param][a83;*R6 $$2,5#31310162474203024125188417583966:caption][b83;*4 "
"$$3,5#07864147445237544204411237157677:title][i288;O9;C2 $$4,6#40027414424643823182269349404212:item][b42;a42;2 "
"$$5,5#45413000475342174754091244180557:text][l288;b17;a17;2 $$6,6#27521748481378242620020725143825:desc][l321;t246;C@5;1 "
"$$7,7#20902679421464641399138805415013:code][b2503; $$8,0#65142375456100023862071332075487:separator][*@(0.0.255)2 "
"$$9,0#83433469410354161042741608181528:base][t4167;C $$10,0#37138531426314131251341829483380:class][l288;a17;*1 "
"$$11,11#70004532496200323422659154056402:requirement][i417;b42;a42;O9;~~~.416;2 $$12,12#10566046415157235020018451313112:tparam][b167;C2 "
"$$13,13#92430459443460461911108080531343:item1][i288;a42;O9;C2 $$14,14#77422149456609303542238260500223:item2][*@2$(0.128.128) "
"$$15,15#34511555403152284025741354420178:NewsDate][l321;*C$7;2 $$16,16#03451589433145915344929335295360:result][l321;b83;a83;*C$7;2 "
"$$17,17#07531550463529505371228428965313:result`-line][l160;t4167;*C+117 $$18,5#88603949442205825958800053222425:package`-title][ "
"$$19,0#53580023442335529039900623488521:gap][t4167;C2 $$20,20#70211524482531209251820423858195:class`-nested][b50;2 "
"$$21,21#03324558446220344731010354752573:Par][{_}%EN-US [s2; About Callbacks and "
"Bars&][s0; This article tries to explain callback types and function overloads involved "
"in Bar operations (MenuBar, ToolBar).&][s0; &][s0; The typical pattern you can see "
"in U`+`+ code for handling Bars looks like this:&][s0; &][s7; void HelloWorld`::About()&][s7; "
"`{&][s7; -|...&][s7; `}&][s7; &][s7; void HelloWorld`::FileMenu(Bar`& bar)&][s7; "
"`{&][s7; -|bar.Add(`\"About..`\", THISBACK(About));&][s7; -|bar.Separator();&][s7; "
"-|bar.Add(`\"Exit`\", THISBACK(Close));&][s7; `}&][s7; &][s7; HelloWorld`::HelloWorld()&][s7; "
"`{&][s7; -|menu.Add(`\"File`\", THISBACK(FileMenu));&][s0; &][s0; Here THISBACK macro "
"expands to &][s0; &][s0; ")
TOPIC_TEXT(
"-|[* callback](this, `&HelloWorld`::FileMenu)&][s0; &][s0; [* callback] is an overloaded "
"non member template function and it has overloads that allow the member function "
"being called back to have none, 1,2,3 or 4 arguments so the FileMenu function can "
"have none, 1,2,3,4 parameters and the appropriate overload of callback will be selected. "
"The actual arguments that are passed to the called back function when it is called "
"are provided by the event dispatcher which knows how many arguments it needs to pass "
"for a particular event. You can see this with the Callback1MethodAction class below "
"where the Execute member function takes one parameter (provided by the event dispatcher) "
"and passes it to thecallback function.&][s0; &][s0; The confusion comes with THISBACK1 "
"and you can see the CallbackMethodActionArg class (below) Execute member function "
"also calls the callback function with one argument `- but this time the argument "
"comes not from the event dispatcher but from the stored member arg of the CallbackMethodActionArg "
"object that is created using `\"new`\" when the callback is assigned i.e. when you "
"do THISBACK1(x, arg) the value of arg becomes the stored member arg of the action "
"object created with new.&][s0; &][s0; If you use THISBACK1 with a member function "
"that takes two arguments, the CallbackMethodActionArg1 class is used and you can "
"see below the member function takes two parameters, the first of which is supplied "
"by the event dispatcher and the second is the stored argument used in the THISBACK1 "
"macro invocation.&][s0; &][s0; If the member function used in the THISBACK macro "
"is overloaded (e.g. FileMenu(int)) then the code won`'t compile. In this case you "
"have to use a forwarding member function that is not overloaded. (you can`'t supply "
"argument types when you take the address of a member function `- if the function "
"is overloaded, the one that`'s chosen depends on the target, but in this case the "
"target is also overloaded so it can`'t be resolved).&][s0; &][s0; T")
TOPIC_TEXT(
"o make matters even more confusing, the Add member function of Bar is also overloaded "
"and which one gets called depends on the return value of the callback function that "
"the compiler chooses `- for the given example, the return type of the chosen callback "
"function is Callback1<Bar`&>. (Callback classes start with upper case C and callback "
"functions have lower case c). &][s0; ]")
